<!DOCTYPE html>
<html lang="en">

<head>
	<title>paymentCRUD</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

	<link rel="stylesheet" href="mystyle.css">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Payment</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label>Customer</label>
				</div>
				<div class="col-sm-9">
					<select id="customer-select" class="form-control">
						<option value="NONE_SELECTED">Chọn Customer</option>
					</select>
				</div>
			</div>

		</div>
		<!-- Create voucher modal -->
		<div>
			<div id="create-payment-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Create new Payment</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>checkNumber</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-checkNumber" class="form-control">
									</div>
								</div>

								<div class="row form-group">
									<div class="col-sm-3">
										<label>paymentDate</label>
									</div>
									<div class="col-sm-9">
										<input type="datetime-local" id="input-paymentDate" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>amount</label>
									</div>
									<div class="col-sm-9">
										<input type="number" id="input-amount" name="note" class="form-control">
									</div>
								</div>



							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-create-payment">Create Payment</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-order-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Update Payment</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>checkNumber</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-checkNumber-update" class="form-control">
									</div>
								</div>

								<div class="row form-group">
									<div class="col-sm-3">
										<label>paymentDate</label>
									</div>
									<div class="col-sm-9">
										<input type="datetime-local" id="input-paymentDate-update" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>amount</label>
									</div>
									<div class="col-sm-9">
										<input type="number" id="input-amount-update" name="note" class="form-control">
									</div>
								</div>



							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-update-payment">Update Product</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Payment Delete Confirmation</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa payment này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-payment">Confirm</button>
							<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<button class="btn btn-success " id="create-payment">Add Payment</button>
		<table class="table table-bordered table-striped table-hover" id="payment-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>checkNumber</th>
					<th>paymentDate</th>
					<th>amount</th>
					<th>customer name</th>


					<th>Action</th>
				</tr>
		</table>
	</div>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gPAYMENT_COLS = ["id", "checkNumber", "paymentDate", "amount", "action"];

		// Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
		const gPAYMENT_STT_COL = 0;
		const gPAYMENT_NUMBER_COL = 1;
		const gPAYMENT_DATE_COL = 2;
		const gPAYMENT_AMOUNT_COL = 3;
		const gPAYMENT_CUSTOMER_NAME_COL = 4;
		const gPAYMENT_ACTION_COL = 5;


		var table = $("#payment-table").DataTable({
			columns: [
				{ data: gPAYMENT_COLS[gPAYMENT_STT_COL] },
				{ data: gPAYMENT_COLS[gPAYMENT_NUMBER_COL] },
				{ data: gPAYMENT_COLS[gPAYMENT_DATE_COL] },
				{ data: gPAYMENT_COLS[gPAYMENT_AMOUNT_COL] },
				{ data: gPAYMENT_COLS[gPAYMENT_CUSTOMER_NAME_COL] },
				{ data: gPAYMENT_COLS[gPAYMENT_ACTION_COL] },


			],
			columnDefs: [
				{ // định nghĩa lại cột action
					targets: gPAYMENT_ACTION_COL,
					defaultContent: `
					<i class="fas fa-edit edit-payment"></i>
					<i class="fas fa-trash-alt delete-payment"></i>
			  		`
				},
				{ // định nghĩa lại cột action
					targets: gPAYMENT_CUSTOMER_NAME_COL,
					render: function (data) {

						data = gCustomerSelected.firstName + " " + gCustomerSelected.lastName
						return data;
					},
				}
			]
		})
		$(document).ready(function () {
			callApiToGetCustomer();
			//create new photo
			$('#create-payment').on('click', function () {
				onBtnAddPaymentClick();
			})
			$('#btn-create-payment').on('click', function () {

				onBtnPaymentOnModalClick();
			})
			//edit photo
			$('#payment-table').on('click', '.edit-payment', function () {


				onBtnEditPaymentClick(this);
			})
			$('#btn-update-payment').on('click', function () {

				onBtnUpdateOnModalClick()
			})

			//xóa photo
			$('#payment-table').on('click', '.delete-payment', function () {

				onBtnDeletePaymentClick(this);
			})
			$('#btn-confirm-delete-payment').on('click', function () {

				onBtnConfirmOnDeleteModalClick(this);
			})

		})

		var gRowSelected = ''
		var gCustomerList = '';
		var gCustomerIdSelected = '';
		var glistOrder = [];
		var gRowPhotoSelected = '';
		var gPaymentIdSelected = '';
		var gCustomerSelected = ''

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */


		//hàm thực hiện khi nhấn nút add new photo
		function onBtnAddPaymentClick() {
			$("#create-payment-modal").modal("show");

		}

		//hàm thực hiện khi lúc nút edit
		function onBtnEditPaymentClick(paramButton) {
			$("#update-order-modal").modal("show");
			gPaymentIdSelected = getPaymentIdFromButton(paramButton)

			console.log('check id payment selected', gPaymentIdSelected)
			callApiToGetPaymentById(gPaymentIdSelected)
		}
		//hàm thực hiện khi nhấn nút update trên modal
		function onBtnUpdateOnModalClick() {
			updateProduct(gPaymentIdSelected);
			$("#update-order-modal").modal("hide");


		}

		//Hàm thực hiện khi nhấn nút delete
		function onBtnDeletePaymentClick(paramButton) {
			$("#delete-modal").modal("show");
			gPaymentIdSelected = getPaymentIdFromButton(paramButton)

		}
		//hàm thực hiện khi nhấn nút confirm trên delete modal
		function onBtnConfirmOnDeleteModalClick() {
			deletedPayment();
			$("#delete-modal").modal("hide");

		}


		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

		function setDataForCustomerNameColumn(data, gCustomerIdSelected) {
			data = gCustomerSelected.firstName + gCustomerSelected.lastName
		}
		/*** DELETE-------------------------------------------------------------------------- */
		function deletedPayment() {
			callApiToDeleteData(gPaymentIdSelected);
			onPageLoading();
		}
		function callApiToDeleteData(id) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/payment/delete/${id}`,
				type: 'DELETE',
				async: false,
				// contentType: "application/json;charset=UTF-8",
				// data: JSON.stringify(paramOrderObject),
				success: function (res) {
					alert('Delete success')

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
		/*** UPDATE-------------------------------------------------------------------------- */


		function updateProduct(paramOrderId) {
			let objData = {
				checkNumber: '',
				paymentDate: '',
				amount: '',
			}

			let objDataFromForm = getDataOnFormUpdate(objData);
			console.log("check UPDATE", objDataFromForm)
			callApiToUpdateData(paramOrderId, objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	let photoExist = '';
			// 	if (glistOrder && glistOrder.length > 0) {

			// 		for (let i = 0; i < glistOrder.length; i++) {
			// 			if (glistOrder[i].photoCode == objDataFromForm.photoCode) {
			// 				alert("photo existed");
			// 				photoExist = glistOrder[i];
			// 				console.log('Album existed', photoExist)
			// 			}
			// 		}

			// 	}
			// 	if (photoExist == '') {
			// 		callApiToUpdateData(paramOrderId, objDataFromForm);
			// 		onPageLoading();
			// 	}



			// }
		}

		//hàm thu thập dư liệu trên form update
		function getDataOnFormUpdate(obj) {
			obj.checkNumber = $('#input-checkNumber-update').val();
			obj.paymentDate = $('#input-paymentDate-update').val();
			obj.amount = $('#input-amount-update').val();
			return obj
		}
		//hàm gọi api để update album
		function callApiToUpdateData(id, paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/payment/update/${id}`,
				type: 'PUT',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {
					console.log('check data update payment response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}


		//hàm trả ra id photo khi nhấn nút edit
		function getPaymentIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			gRowPhotoSelected = table.row(vTableRow).data();
			console.log(gRowPhotoSelected.id);
			return gRowPhotoSelected.id;
		}
		//hàm gọi api để lấy photo cần edit theo id
		function callApiToGetPaymentById(id) {

			$.ajax({
				url: `http://localhost:8080/payment/details/${id}`,
				async: false,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check data payment need to update ress', res);
					// if (glistAlbum && glistAlbum.length > 0) {
					// 	glistAlbum.map((item, index) => {
					// 		if (item.id == res.id) {
					// 			glistAlbum.splice(index, 1)
					// 		}
					// 	})
					// }
					showDataUpdateOnForm(res);
				},
				error: function (err) {
					console.log(err.response);
				}
			})

		}
		//hàm hiển thị data lên form edit
		function showDataUpdateOnForm(paramPhoto) {



			$('#input-checkNumber-update').val(paramPhoto.checkNumber);
			$('#input-paymentDate-update').val(paramPhoto.paymentDate);
			$('#input-amount-update').val(paramPhoto.amount);
		}

		/*** CREATE-------------------------------------------------------------------------- */
		//hàm thực hiện khi nhấn create photo trên modal
		function onBtnPaymentOnModalClick() {
			createNewPayment();
			$("#create-payment-modal").modal("hide");
		}
		//save new photo
		function createNewPayment() {
			let objData = {
				checkNumber: '',
				paymentDate: '',
				amount: '',

			}
			let objDataFromForm = getDataOnForm(objData);
			console.log("check product object", objDataFromForm)
			callApiToPostData(objDataFromForm);
			onPageLoading();

			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	if (glistOrder && glistOrder.length > 0) {
			// 		glistOrder.map(item => {
			// 			if (item.photoCode == objDataFromForm.photoCode) {
			// 				alert("photo existed")
			// 			} else {
			// 				console.log('check data post', objDataFromForm)
			// 				callApiToPostData(objDataFromForm);
			// 				onPageLoading();

			// 			}
			// 		})
			// 	}

			// }

		}
		//hàm thực hiện validate dữ liệu trên form
		// function validateDataOnform(paramObjData) {
		// 	if (!paramObjData.photoCode) {
		// 		alert('Missing photo code')
		// 		return false;
		// 	}
		// 	if (!paramObjData.photoName) {
		// 		alert('Missing photo name')
		// 		return false;
		// 	}
		// 	if (!paramObjData.photoLink) {
		// 		alert('Missing photo link')
		// 		return false;
		// 	}
		// 	if (!paramObjData.photoDescription) {
		// 		alert('Missing photo description')
		// 		return false;
		// 	}
		// 	return true;


		// }
		//hàm thu thập dư liệu trên form
		function getDataOnForm(obj) {

			obj.checkNumber = $('#input-checkNumber').val();
			obj.paymentDate = $('#input-paymentDate').val();
			obj.amount = $('#input-amount').val();

			return obj
		}
		//hàm gọi api để tạo album mới
		function callApiToPostData(paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/payment/create/${gCustomerIdSelected}`,
				type: 'POST',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {

					console.log('check data post response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
































		function callApiToGetCustomer() {
			$.ajax({
				async: false,
				url: "http://localhost:8080/customer/all",
				method: "GET",
				success: function (pObjRes) {
					gCustomerList = pObjRes
					loadDataToCustomerSelect(gCustomerList);
					console.log('check response customer', pObjRes)

				},
				error: function (pXhrObj) {
					console.log(pXhrObj);
				}
			});
		}
		var gCustomerSelectElement = $("#customer-select");
		//hàm load thông tin album vào ô select
		function loadDataToCustomerSelect(pCustomerList) {

			for (i = 0; i < pCustomerList.length; i++) {
				var bPaymentOption = $("<option/>");
				bPaymentOption.prop("value", pCustomerList[i].id);
				bPaymentOption.prop("text", pCustomerList[i].lastName + "" + pCustomerList[i].firstName);
				gCustomerSelectElement.append(bPaymentOption);
			};
		}
		//hàm xử lí chọn album
		gCustomerSelectElement.on("change", function () {
			if (gCustomerList && gCustomerList.length > 0) {
				gCustomerList.map(item => {
					if (item.id == $(this).val()) {
						gCustomerIdSelected = item.id
						gCustomerSelected = item
					}
				})
			}
			console.log('check custoemr id id', gCustomerIdSelected)
			onPageLoading();

		})
		function onPageLoading() {
			$.ajax({
				url: `http://localhost:8080/customer/${gCustomerIdSelected}/payments`,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check payment by id', res);
					glistOrder = res
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}









	</script>
</body>

</html>